jv.project

## Interface PvGeometryIf

- All Known Implementing Classes:
    PvGeometry

      public interface PvGeometryIf

  Interface to container geometry used in JavaView displays. Methods specified in this interface are used to transfer data from a geometry class to the display in the geometry's paint method. Each subclass of jv.project.PgGeometry should derive or implement a method paint(PvGeometryIf dc) in which methods of this interface are called to transfer data to container geometry in display.
  See Also:
    `PgGeometryIf`, `PvDisplayIf`, `PvDisplay`
  Author:
    Konrad Polthier
  Version:
    02.07.06, 5.20 revised (kp) Edge handling improved, including color and size.
    29.02.04, 5.00 revised (kp) Methods on vectorFields removed which were deprecated before JavaView v2.21.
    17.01.04, 4.00 revised (kp) Several unused methods removed which assign data for individual elements.
    19.05.01, 3.20 revised (kp) Vector field handling slightly revised.
    30.09.00, 3.10 revised (kp) Static variables USE_GLOBAL.. renamed to SHOW_...
    26.09.00, 3.00 revised (kp) Merge of PgJvxSrc and PvGeometry.
    21.09.00, 2.35 revised (kp) Methods for global backface element color added.
    24.07.00, 2.30 revised (kp) Method for passing label offset added.
    07.07.00, 2.21 revised (kp) Names of geometry type prepended with GEOM_.
    23.06.00, 2.20 revised (kp) Flags for tagged items added.
    02.04.00, 2.10 revised (kp) Everywhere PdColor replaced with Color.
    09.02.00, 2.01 revised (kp) Outline flag added.
    26.12.99, 2.00 revised (kp) Interface no longer extends PgGeometryIf.
    02.08.98, 1.01 revised (kp) Vector field support added.
    09.02.98, 1.00 created (kp)

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `static int` | `DRAW_FRAME` Draw frame geometry at fixed position on display.
    `static int` | `DRAW_ORDER_BACK` Draw geometry in a back layer of a display, for example, to draw in the background.
    `static int` | `DRAW_ORDER_FRONT` Draw geometry in a front layer of a display, for example, to enforce its drawing.
    `static int` | `DRAW_ORDER_STANDARD` Draw geometry as part of a scene where different geometries may obscure each other.
    `static int` | `ENABLE_DEFAULT_LABEL`
    `static int` | `ENABLE_NEIGHBOUR` In rare situations usage of neighbour information may be switched off.
    `static int` | `GEOM_BOUNDARY_POLYGON` Identifier for boundary polygon.
    `static int` | `GEOM_ELEMENT_SET` Identifier for an element set geometry.
    `static int` | `GEOM_ITEM_EDGE` Identifier for edge geometry item.
    `static int` | `GEOM_ITEM_ELEMENT` Identifier for element geometry item.
    `static int` | `GEOM_ITEM_NAME` Identifier for individual name of geometry item.
    `static int` | `GEOM_ITEM_POINT` Identifier for vertex geometry item.
    `static int` | `GEOM_ITEM_POLYGON` Identifier for polygon geometry item.
    `static int` | `GEOM_ITEM_TETRA` Identifier for tetrahedron geometry item.
    `static int` | `GEOM_ITEM_TITLE` Identifier for general grouping title of geometry item.
    `static int` | `GEOM_POINT_SET` Identifier for point set geometry.
    `static int` | `GEOM_POLYGON` Identifier for polygon geometry.
    `static int` | `GEOM_POLYGON_SET` Identifier for polygon set geometry.
    `static int` | `GEOM_TETRA_SET` Identifier for a volume geometry of tetrahedra.
    `static int` | `GEOM_UNKNOWN` Identifier for unknown geometry type.
    `static int` | `GEOM_VECTOR_FIELD` Identifier for a vector field.
    `static int` | `IGNORE_DEPTHCUE` Ignore using depthcue rendering on this geometry.
    `static int` | `IGNORE_LIGHTING`
    `static int` | `INDUCE_ELEMENT_FROM_VERTEX_COLORS` deprecated since 3.96.031, use SHOW_ELEMENT_COLOR_FROM_VERTICES instead.
    `static int` | `IS_BOUNDARY` Internal tag to identify a geometry or individual geometry items as being part of the boundary.
    `static int` | `IS_CREASE` Internal tag to identify a vertex as part of a crease edge.
    `static int` | `IS_HIDDEN` Internal tag to hide geometry in display.
    `static int` | `IS_PICKED` Internal tag to identify a geometry or individual geometry items as being currently picked.
    `static int` | `IS_SYMMETRY` Deprecated. since JavaView 1.99.8, no replacement
    `static int` | `SHOW_BACKFACE`
    `static int` | `SHOW_BNDBOX`
    `static int` | `SHOW_BOUNDARIES`
    `static int` | `SHOW_CENTER`
    `static int` | `SHOW_EDGE_COLOR_FROM_ELEMENTS`
    `static int` | `SHOW_EDGE_COLOR_FROM_VERTICES`
    `static int` | `SHOW_EDGE_COLORS`
    `static int` | `SHOW_EDGE_LABELS`
    `static int` | `SHOW_EDGE_SIZES`
    `static int` | `SHOW_EDGES`
    `static int` | `SHOW_ELEMENT_BACK_COLOR`
    `static int` | `SHOW_ELEMENT_BACK_COLORS`
    `static int` | `SHOW_ELEMENT_COLOR_FROM_VERTICES`
    `static int` | `SHOW_ELEMENT_COLORS`
    `static int` | `SHOW_ELEMENT_LABELS`
    `static int` | `SHOW_ELEMENT_NORMAL_ARROW`
    `static int` | `SHOW_ELEMENT_NORMALS`
    `static int` | `SHOW_ELEMENT_TEXTURE`
    `static int` | `SHOW_ELEMENTS`
    `static int` | `SHOW_INDICES`
    `static int` | `SHOW_NAME` Enables showing of the name of a geometry.
    `static int` | `SHOW_OUTLINE` Deprecated. use SHOW_SILHOUETTE
    `static int` | `SHOW_POLYGON_COLORS`
    `static int` | `SHOW_POLYGON_END_ARROW`
    `static int` | `SHOW_POLYGON_LABELS`
    `static int` | `SHOW_POLYGON_NORMAL_ARROW` Enables drawing of polygon normals.
    `static int` | `SHOW_POLYGON_NORMALS` Enables drawing of polygon normals.
    `static int` | `SHOW_POLYGON_SIZES`
    `static int` | `SHOW_POLYGON_START_ARROW`
    `static int` | `SHOW_POLYGONS`
    `static int` | `SHOW_SILHOUETTE` Draw a thickened line along the silhouette of a surface.
    `static int` | `SHOW_SMOOTH_EDGE_COLORS`
    `static int` | `SHOW_SMOOTH_ELEMENT_COLORS`
    `static int` | `SHOW_SMOOTH_LIGHTING`
    `static int` | `SHOW_SMOOTH_SHADING`
    `static int` | `SHOW_TAGGED_BOUNDARIES`
    `static int` | `SHOW_TAGGED_EDGES`
    `static int` | `SHOW_TAGGED_ELEMENTS`
    `static int` | `SHOW_TAGGED_POLYGONS`
    `static int` | `SHOW_TAGGED_VERTICES`
    `static int` | `SHOW_TEXTURE_BACK`
    `static int` | `SHOW_TEXTURE_FRONT`
    `static int` | `SHOW_TITLE` Enables showing of the grouping title of a geometry.
    `static int` | `SHOW_TRANSPARENCY`
    `static int` | `SHOW_VECTOR_ARROWS`
    `static int` | `SHOW_VECTOR_COLORS`
    `static int` | `SHOW_VECTORS`
    `static int` | `SHOW_VERTEX_COLORS`
    `static int` | `SHOW_VERTEX_LABELS`
    `static int` | `SHOW_VERTEX_NORMAL_ARROW`
    `static int` | `SHOW_VERTEX_NORMALS`
    `static int` | `SHOW_VERTEX_OUTLINE` Draw a black circle around the (optionally colored) disk which is used to render of each vertex.
    `static int` | `SHOW_VERTEX_SIZES` Enables use of individual thickness of vertices of a geometry.
    `static int` | `SHOW_VERTEX_TEXTURE`
    `static int` | `SHOW_VERTICES`
    `static int` | `USER_BIT` Possible tags used by a display to mark the geometry, individual vertices or elements, see tag methods below.

  - ### Method Summary

    All Methods Instance Methods Abstract Methods
    Modifier and Type | Method and Description
    --- | ---
    `int` | `getAmbientProjection()` Get projection mode of ambient space used in model transformations.
    `int` | `getAmbientSpace()` Get ambient space used in model transformations.
    `int` | `getDrawingOrder()` Set position of geometry in z-direction in display.
    `PgGeometryIf` | `getGeometry()` Get associated geometry to be displayed.
    `void` | `init()` Reset geometry container.
    `boolean` | `isVisible()` Flag whether geometry is hidden or visible in display.
    `void` | `setAmbientMatrix(PdMatrix ambientMat, PdMatrix ambientInvMat)` Set model matrix of geometry within original ambient space.
    `void` | `setAmbientProjection(int mode)` Set projection mode of ambient space used in model transformations.
    `void` | `setAmbientSpace(int mode)` Set ambient space used in model transformations.
    `boolean` | `setBndColor(int ind, java.awt.Color color)` Set global color of individual boundary polygon unless all have same color.
    `void` | `setBndElementInd(int ind, PiVector elemInd)` Set indices of surface elements along boundary.
    `void` | `setBndName(int ind, java.lang.String name)` Set thickness in pixels of boundary polygon.
    `void` | `setBndNeighbourLocInd(int ind, PiVector oppLocInd)` Set local indices of opposite vertices of edge in surface element.
    `boolean` | `setBndSize(int ind, double size)` Set thickness in pixels of boundary polygon.
    `void` | `setCenter(PdVector aVertex)` Set center of geometry different from center of gravity.
    `void` | `setCreaseAngle(double angle)` Set crease angle which is a threshold determining sharp crease edges.
    `void` | `setDimOfElements(int dim)` Set dimension of element used in geometry, i.e. the number vertices per element.
    `void` | `setDimOfPolygons(int dim)` Set dimension of polygons used in geometry, i.e. the number vertices per polygon.
    `void` | `setDimOfVertices(int dim)` Set dimension of points used in geometry, i.e. the number coordinates per point.
    `void` | `setDrawingOrder(int anOrder)` Set position of geometry in z-direction in display.
    `void` | `setEdgeColors(java.awt.Color[] color)` Set individual color of all edges.
    `void` | `setEdges(PiVector[] edge)` Set list of all edges.
    `void` | `setEdgeSizes(PdVector size)` Set individual thickness of all edges.
    `void` | `setElementBackColors(java.awt.Color[] color)` Set individual backface colors of elements.
    `void` | `setElementColors(java.awt.Color[] colors)` Set individual colors of elements.
    `void` | `setElementEdges(PiVector[] elementEdge)` Set for all elements a list of indices of incident edges.
    `void` | `setElementNormals(PdVector[] normals)` Set individual normals of elements.
    `void` | `setElements(PiVector[] elements)` Set elements of geometry.
    `void` | `setElementTextures(PdVector[][] texCoords)` Set individual texture coordinates for all vertices of all elements.
    `void` | `setGeometry(PgGeometryIf aGeometry)` Set associated geometry to be displayed.
    `void` | `setGlobalBndColor(java.awt.Color color)` Set global boundary color.
    `void` | `setGlobalBndSize(double aSize)` Set global thickness of boundary edges.
    `void` | `setGlobalBndTagColor(java.awt.Color color)` Set global color of tagged boundaries.
    `void` | `setGlobalEdgeColor(java.awt.Color color)` Set global edge color to be used if no local colors are available.
    `void` | `setGlobalEdgeSize(double aSize)` Set global thickness of element edges.
    `void` | `setGlobalEdgeTagColor(java.awt.Color color)` Set global color of tagged edges.
    `void` | `setGlobalElementBackColor(java.awt.Color color)` Set global color of backface of elements.
    `void` | `setGlobalElementColor(java.awt.Color color)` Set global element color to be used if no local colors are available.
    `void` | `setGlobalElementNormalColor(java.awt.Color color)` Set global vertex normal color.
    `void` | `setGlobalElementNormalLength(double aLength)` Set global length of vertex normal vectors.
    `void` | `setGlobalElementNormalSize(double aSize)` Set global thickness of vertex normal vectors.
    `void` | `setGlobalElementTagColor(java.awt.Color color)` Set global color of tagged elements.
    `void` | `setGlobalPolygonColor(java.awt.Color color)` Set global polygon color to be used if no local colors are available.
    `void` | `setGlobalPolygonNormalColor(java.awt.Color color)` Set global color of polygon normals.
    `void` | `setGlobalPolygonNormalLength(double aLength)` Set global length of polygon normal vectors.
    `void` | `setGlobalPolygonNormalSize(double aSize)` Set global thickness of polygon normal vectors.
    `void` | `setGlobalPolygonSize(double aSize)` Set global thickness of polygon edges.
    `void` | `setGlobalPolygonTagColor(java.awt.Color color)` Set global color of tagged polygons.
    `boolean` | `setGlobalVectorColor(int ind, java.awt.Color aColor)` Set global color of vector field to be used if no local colors are available.
    `boolean` | `setGlobalVectorLength(int ind, double aLength)` Set length factor of vectors when drawn in display.
    `boolean` | `setGlobalVectorSize(int ind, double aSize)` Set thickness in pixels of vectors when drawn in display.
    `void` | `setGlobalVertexColor(java.awt.Color color)` Set global vertex color to be used if no local colors are available.
    `void` | `setGlobalVertexNormalColor(java.awt.Color color)` Set global vertex normal color.
    `void` | `setGlobalVertexNormalLength(double aLength)` Set global length of vertex normal vectors.
    `void` | `setGlobalVertexNormalSize(double aSize)` Set global thickness of vertex normal vectors.
    `void` | `setGlobalVertexSize(double aSize)` Set global thickness of vertex dots.
    `void` | `setGlobalVertexTagColor(java.awt.Color color)` Set global vertex color to be used if no local colors are available.
    `boolean` | `setLabelAttributes(PiVector[] attr)` Set attribute vector in pixel coordinates of label w.r.t. base point.
    `void` | `setLabelColors(java.awt.Color[] col)` Set colors of all label types.
    `void` | `setLabelFonts(java.lang.String[] name)` Set font names of all label types.
    `void` | `setLabelSizes(PdVector size)` Set font sizes of all label types.
    `void` | `setLabelStyles(PiVector style)` Set font styles of all label types.
    `void` | `setModelMatrix(PdMatrix modelMat)` Set model matrix of geometry.
    `void` | `setNeighbours(PiVector[] neighbours)` Set individual neighbours of elements.
    `void` | `setNumBndPolygons(int num)` Set number of allocated and used vector fields.
    `void` | `setNumEdges(int numEdges)` Set number of edges of an element set.
    `void` | `setNumElements(int numElements)` Set number of elements of geometry.
    `void` | `setNumPolygons(int numPolygons)` Set number of polygons of geometry.
    `void` | `setNumVectorFields(int num)` Set number of allocated and used vector fields.
    `void` | `setNumVectors(int ind, int num, int dimOfVectors)` Set number of vectors of a vector field with given index.
    `void` | `setNumVertices(int numVertices)` Set number of used vertices.
    `void` | `setPolygonColors(java.awt.Color[] colors)` Set individual colors of polygons.
    `void` | `setPolygonNormals(PdVector[] normals)` Set individual normal vectors of polygons.
    `void` | `setPolygons(PiVector[] vertices)` Set polygons of geometry.
    `void` | `setPolygonSizes(PdVector sizes)` Set individual thickness of polygon edges.
    `void` | `setShininess(double shininess)` Set shininess of geometry.
    `void` | `setSpecularColor(java.awt.Color col)` Set specular color of geometry.
    `void` | `setState(int aKey, boolean aValue)` Enable/disable the showing of parts of the geometry, e.g. set(PvGeometryIf.SHOW_VERTICES, true) enables the showing of vertices in the viewer.
    `void` | `setTexture(int[] texturePix, int width, int height, int blendingMode, int filteringType)` Set texture image as array of pixels and image dimensions with no multiple repetition.
    `void` | `setTexture(int[] texturePix, int width, int height, int uRepeat, int vRepeat, int periodic, int blendingMode, int filteringType, int textureSide)` Set texture image as array of pixels and image dimensions with multiple repetition.
    `void` | `setTransparency(double alpha)` Set transparency in [0, 1] where 0 corresponds to opaque and 1 to fully transparent.
    `void` | `setVectorColors(int ind, java.awt.Color[] list)` Copy vector colors of list to existing array of vector colors.
    `void` | `setVectorElementBased(int ind, boolean flag)` Set flag if vector field is element based or vertex based.
    `void` | `setVectors(int ind, PdVector[] list)` Copy all vectors of vector list to existing array of vectors.
    `void` | `setVertexColors(java.awt.Color[] colors)` Set array of vertex colors.
    `void` | `setVertexNormals(PdVector[] normals)` Set array of vertex normal vectors.
    `void` | `setVertexSizes(PdVector sizes)` Set individual thickness of all vertices.
    `void` | `setVertexTextures(PdVector[] tex)` Set array of vertex texture coordinates.
    `void` | `setVertices(PdVector[] vertices)` Set array of vertex coordinates.
    `void` | `setVisible(boolean flag)` Set geometry to be hidden or visible in display.
    `void` | `showBnd(int ind, boolean flag)` Set visibility of boundary polygon.
    `void` | `showBndMaterials(int ind, boolean flag)` Set flag if this boundary polygon uses its own material properties instead of inheriting material properties of the base geometry.
    `void` | `showVectorArrows(int ind, boolean flag)` Set flag if tip of vectors is shown as arrow.
    `void` | `showVectorColors(int ind, boolean flag)` Set flag to enable drawing of individual vertex colors of a vector field.
    `void` | `showVectorField(int ind, boolean flag)` Set flag to enable drawing of vectors of a vector field.
    `void` | `showVectorFields(boolean flag)` Set flag to enable drawing of all vector fields which are visible.
    `boolean` | `update(java.lang.Object event)` Invoke update of geometry container.

- - ### Field Detail

    - #### GEOM_UNKNOWN

          static final int GEOM_UNKNOWN

      Identifier for unknown geometry type.
      See Also:
        Constant Field Values

    - #### GEOM_POINT_SET

          static final int GEOM_POINT_SET

      Identifier for point set geometry.
      See Also:
        Constant Field Values

    - #### GEOM_POLYGON

          static final int GEOM_POLYGON

      Identifier for polygon geometry.
      See Also:
        Constant Field Values

    - #### GEOM_POLYGON_SET

          static final int GEOM_POLYGON_SET

      Identifier for polygon set geometry.
      See Also:
        Constant Field Values

    - #### GEOM_ELEMENT_SET

          static final int GEOM_ELEMENT_SET

      Identifier for an element set geometry.
      See Also:
        Constant Field Values

    - #### GEOM_TETRA_SET

          static final int GEOM_TETRA_SET

      Identifier for a volume geometry of tetrahedra.
      See Also:
        Constant Field Values

    - #### GEOM_BOUNDARY_POLYGON

          static final int GEOM_BOUNDARY_POLYGON

      Identifier for boundary polygon.
      See Also:
        Constant Field Values

    - #### GEOM_VECTOR_FIELD

          static final int GEOM_VECTOR_FIELD

      Identifier for a vector field.
      See Also:
        Constant Field Values

    - #### GEOM_ITEM_POINT

          static final int GEOM_ITEM_POINT

      Identifier for vertex geometry item.
      See Also:
        Constant Field Values

    - #### GEOM_ITEM_EDGE

          static final int GEOM_ITEM_EDGE

      Identifier for edge geometry item.
      See Also:
        Constant Field Values

    - #### GEOM_ITEM_POLYGON

          static final int GEOM_ITEM_POLYGON

      Identifier for polygon geometry item.
      See Also:
        Constant Field Values

    - #### GEOM_ITEM_ELEMENT

          static final int GEOM_ITEM_ELEMENT

      Identifier for element geometry item.
      See Also:
        Constant Field Values

    - #### GEOM_ITEM_TETRA

          static final int GEOM_ITEM_TETRA

      Identifier for tetrahedron geometry item.
      See Also:
        Constant Field Values

    - #### GEOM_ITEM_NAME

          static final int GEOM_ITEM_NAME

      Identifier for individual name of geometry item.
      See Also:
        Constant Field Values

    - #### GEOM_ITEM_TITLE

          static final int GEOM_ITEM_TITLE

      Identifier for general grouping title of geometry item.
      See Also:
        Constant Field Values

    - #### USER_BIT

          static final int USER_BIT

      Possible tags used by a display to mark the geometry, individual vertices or elements, see tag methods below. This set of tags extends the set of tags of PsObject.
      See Also:
        Constant Field Values

    - #### IS_PICKED

          static final int IS_PICKED

      Internal tag to identify a geometry or individual geometry items as being currently picked.
      See Also:
        Constant Field Values

    - #### IS_SYMMETRY

          static final int IS_SYMMETRY

      Deprecated. since JavaView 1.99.8, no replacement
      See Also:
        Constant Field Values

    - #### IS_BOUNDARY

          static final int IS_BOUNDARY

      Internal tag to identify a geometry or individual geometry items as being part of the boundary.
      See Also:
        Constant Field Values

    - #### IS_HIDDEN

          static final int IS_HIDDEN

      Internal tag to hide geometry in display. Users should prefer direct method calls such as `isVisible()`.
      See Also:
        `isVisible()`, `setVisible(boolean)`, Constant Field Values

    - #### IS_CREASE

          static final int IS_CREASE

      Internal tag to identify a vertex as part of a crease edge.
      Since:
        JavaView 3.03.007
      See Also:
        Constant Field Values

    - #### DRAW_ORDER_STANDARD

          static final int DRAW_ORDER_STANDARD

      Draw geometry as part of a scene where different geometries may obscure each other. Visibility is determined by a depth sorting.
      See Also:
        Constant Field Values

    - #### DRAW_ORDER_FRONT

          static final int DRAW_ORDER_FRONT

      Draw geometry in a front layer of a display, for example, to enforce its drawing. Visibility of this shape against other shapes is no longer determined by a depth sorting.
      See Also:
        Constant Field Values

    - #### DRAW_ORDER_BACK

          static final int DRAW_ORDER_BACK

      Draw geometry in a back layer of a display, for example, to draw in the background. Visibility of this shape against other shapes is no longer determined by a depth sorting.
      See Also:
        Constant Field Values

    - #### DRAW_FRAME

          static final int DRAW_FRAME

      Draw frame geometry at fixed position on display.
      See Also:
        Constant Field Values
      HACK:
        temporary for JOGL testing

    - #### SHOW_VERTICES

          static final int SHOW_VERTICES

      See Also:
        Constant Field Values

    - #### SHOW_TAGGED_VERTICES

          static final int SHOW_TAGGED_VERTICES

      See Also:
        Constant Field Values

    - #### SHOW_EDGES

          static final int SHOW_EDGES

      See Also:
        Constant Field Values

    - #### SHOW_TAGGED_EDGES

          static final int SHOW_TAGGED_EDGES

      See Also:
        Constant Field Values

    - #### SHOW_POLYGONS

          static final int SHOW_POLYGONS

      See Also:
        Constant Field Values

    - #### SHOW_TAGGED_POLYGONS

          static final int SHOW_TAGGED_POLYGONS

      See Also:
        Constant Field Values

    - #### SHOW_ELEMENTS

          static final int SHOW_ELEMENTS

      See Also:
        Constant Field Values

    - #### SHOW_TAGGED_ELEMENTS

          static final int SHOW_TAGGED_ELEMENTS

      See Also:
        Constant Field Values

    - #### SHOW_BOUNDARIES

          static final int SHOW_BOUNDARIES

      See Also:
        Constant Field Values

    - #### SHOW_TAGGED_BOUNDARIES

          static final int SHOW_TAGGED_BOUNDARIES

      See Also:
        Constant Field Values

    - #### SHOW_VERTEX_NORMALS

          static final int SHOW_VERTEX_NORMALS

      See Also:
        Constant Field Values

    - #### SHOW_VERTEX_NORMAL_ARROW

          static final int SHOW_VERTEX_NORMAL_ARROW

      See Also:
        Constant Field Values

    - #### SHOW_ELEMENT_NORMALS

          static final int SHOW_ELEMENT_NORMALS

      See Also:
        Constant Field Values

    - #### SHOW_ELEMENT_NORMAL_ARROW

          static final int SHOW_ELEMENT_NORMAL_ARROW

      See Also:
        Constant Field Values

    - #### SHOW_POLYGON_NORMALS

          static final int SHOW_POLYGON_NORMALS

      Enables drawing of polygon normals.
      See Also:
        Constant Field Values

    - #### SHOW_POLYGON_NORMAL_ARROW

          static final int SHOW_POLYGON_NORMAL_ARROW

      Enables drawing of polygon normals.
      See Also:
        Constant Field Values

    - #### SHOW_VECTORS

          static final int SHOW_VECTORS

      See Also:
        Constant Field Values

    - #### SHOW_VECTOR_ARROWS

          static final int SHOW_VECTOR_ARROWS

      See Also:
        Constant Field Values

    - #### SHOW_BACKFACE

          static final int SHOW_BACKFACE

      See Also:
        Constant Field Values

    - #### SHOW_BNDBOX

          static final int SHOW_BNDBOX

      See Also:
        Constant Field Values

    - #### SHOW_CENTER

          static final int SHOW_CENTER

      See Also:
        Constant Field Values

    - #### SHOW_VERTEX_TEXTURE

          static final int SHOW_VERTEX_TEXTURE

      See Also:
        Constant Field Values

    - #### SHOW_ELEMENT_TEXTURE

          static final int SHOW_ELEMENT_TEXTURE

      See Also:
        Constant Field Values

    - #### SHOW_TEXTURE_FRONT

          static final int SHOW_TEXTURE_FRONT

      See Also:
        Constant Field Values

    - #### SHOW_TEXTURE_BACK

          static final int SHOW_TEXTURE_BACK

      See Also:
        Constant Field Values

    - #### SHOW_TRANSPARENCY

          static final int SHOW_TRANSPARENCY

      See Also:
        Constant Field Values

    - #### SHOW_VERTEX_SIZES

          static final int SHOW_VERTEX_SIZES

      Enables use of individual thickness of vertices of a geometry.
      Since:
        JavaView 2.43
      See Also:
        Constant Field Values

    - #### SHOW_INDICES

          static final int SHOW_INDICES

      See Also:
        Constant Field Values

    - #### SHOW_VERTEX_LABELS

          static final int SHOW_VERTEX_LABELS

      See Also:
        Constant Field Values

    - #### SHOW_POLYGON_LABELS

          static final int SHOW_POLYGON_LABELS

      See Also:
        Constant Field Values

    - #### SHOW_EDGE_LABELS

          static final int SHOW_EDGE_LABELS

      See Also:
        Constant Field Values

    - #### SHOW_ELEMENT_LABELS

          static final int SHOW_ELEMENT_LABELS

      See Also:
        Constant Field Values

    - #### ENABLE_DEFAULT_LABEL

          static final int ENABLE_DEFAULT_LABEL

      See Also:
        Constant Field Values

    - #### SHOW_NAME

          static final int SHOW_NAME

      Enables showing of the name of a geometry.
      Since:
        JavaView 2.47
      See Also:
        Constant Field Values

    - #### SHOW_TITLE

          static final int SHOW_TITLE

      Enables showing of the grouping title of a geometry.
      See Also:
        Constant Field Values

    - #### SHOW_SILHOUETTE

          static final int SHOW_SILHOUETTE

      Draw a thickened line along the silhouette of a surface.
      See Also:
        Constant Field Values

    - #### SHOW_OUTLINE

          static final int SHOW_OUTLINE

      Deprecated. use SHOW_SILHOUETTE
      See Also:
        Constant Field Values

    - #### SHOW_POLYGON_START_ARROW

          static final int SHOW_POLYGON_START_ARROW

      See Also:
        Constant Field Values

    - #### SHOW_POLYGON_END_ARROW

          static final int SHOW_POLYGON_END_ARROW

      See Also:
        Constant Field Values

    - #### SHOW_VERTEX_COLORS

          static final int SHOW_VERTEX_COLORS

      See Also:
        Constant Field Values

    - #### SHOW_VECTOR_COLORS

          static final int SHOW_VECTOR_COLORS

      See Also:
        Constant Field Values

    - #### SHOW_POLYGON_COLORS

          static final int SHOW_POLYGON_COLORS

      See Also:
        Constant Field Values

    - #### SHOW_EDGE_COLORS

          static final int SHOW_EDGE_COLORS

      See Also:
        Constant Field Values

    - #### SHOW_EDGE_COLOR_FROM_ELEMENTS

          static final int SHOW_EDGE_COLOR_FROM_ELEMENTS

      See Also:
        Constant Field Values

    - #### SHOW_EDGE_COLOR_FROM_VERTICES

          static final int SHOW_EDGE_COLOR_FROM_VERTICES

      See Also:
        Constant Field Values

    - #### SHOW_EDGE_SIZES

          static final int SHOW_EDGE_SIZES

      See Also:
        Constant Field Values

    - #### SHOW_ELEMENT_COLORS

          static final int SHOW_ELEMENT_COLORS

      See Also:
        Constant Field Values

    - #### SHOW_VERTEX_OUTLINE

          static final int SHOW_VERTEX_OUTLINE

      Draw a black circle around the (optionally colored) disk which is used to render of each vertex.
      See Also:
        Constant Field Values

    - #### SHOW_SMOOTH_SHADING

          static final int SHOW_SMOOTH_SHADING

      See Also:
        Constant Field Values

    - #### SHOW_ELEMENT_BACK_COLOR

          static final int SHOW_ELEMENT_BACK_COLOR

      See Also:
        Constant Field Values

    - #### SHOW_ELEMENT_BACK_COLORS

          static final int SHOW_ELEMENT_BACK_COLORS

      See Also:
        Constant Field Values

    - #### SHOW_SMOOTH_LIGHTING

          static final int SHOW_SMOOTH_LIGHTING

      See Also:
        Constant Field Values

    - #### SHOW_SMOOTH_EDGE_COLORS

          static final int SHOW_SMOOTH_EDGE_COLORS

      See Also:
        Constant Field Values

    - #### SHOW_SMOOTH_ELEMENT_COLORS

          static final int SHOW_SMOOTH_ELEMENT_COLORS

      See Also:
        Constant Field Values

    - #### SHOW_ELEMENT_COLOR_FROM_VERTICES

          static final int SHOW_ELEMENT_COLOR_FROM_VERTICES

      See Also:
        Constant Field Values

    - #### INDUCE_ELEMENT_FROM_VERTEX_COLORS

          static final int INDUCE_ELEMENT_FROM_VERTEX_COLORS

      deprecated since 3.96.031, use SHOW_ELEMENT_COLOR_FROM_VERTICES instead.
      See Also:
        Constant Field Values

    - #### ENABLE_NEIGHBOUR

          static final int ENABLE_NEIGHBOUR

      In rare situations usage of neighbour information may be switched off. For example, non-conforming meshes are rendered without neighbour information.
      See Also:
        Constant Field Values

    - #### SHOW_POLYGON_SIZES

          static final int SHOW_POLYGON_SIZES

      See Also:
        Constant Field Values

    - #### IGNORE_DEPTHCUE

          static final int IGNORE_DEPTHCUE

      Ignore using depthcue rendering on this geometry.
      See Also:
        Constant Field Values

    - #### IGNORE_LIGHTING

          static final int IGNORE_LIGHTING

      See Also:
        Constant Field Values

  - ### Method Detail

    - #### init

          void init()

      Reset geometry container.

    - #### update

          boolean update(java.lang.Object event)

      Invoke update of geometry container.

    - #### getGeometry

          PgGeometryIf getGeometry()

      Get associated geometry to be displayed.

    - #### setGeometry

          void setGeometry(PgGeometryIf aGeometry)

      Set associated geometry to be displayed.

    - #### setState

          void setState(int aKey,
                        boolean aValue)

      Enable/disable the showing of parts of the geometry, e.g. set(PvGeometryIf.SHOW_VERTICES, true) enables the showing of vertices in the viewer.

    - #### setLabelAttributes

          boolean setLabelAttributes(PiVector[] attr)

      Set attribute vector in pixel coordinates of label w.r.t. base point. First two components are pixel coordinates. Third component is in [1..3] and indices whether head, center or tail is located at base+offset. Fourth component indicates font. For possible type see `PvGeometryIf#GEOM_ITEM_POINT` and other items. Note, (0,0) is in the upper left corner of the screen.
      Parameters:
        `attr` - Array of attribute vectors

    - #### setLabelColors

          void setLabelColors(java.awt.Color[] col)

      Set colors of all label types.
      Parameters:
        `col` - Array of label type

    - #### setLabelSizes

          void setLabelSizes(PdVector size)

      Set font sizes of all label types.
      Parameters:
        `size` - Vector with font sizes
      Since:
        JavaView 3.52.002
      Version:
        15.08.04, 1.00 created (kp)

    - #### setLabelStyles

          void setLabelStyles(PiVector style)

      Set font styles of all label types.
      Parameters:
        `style` - Vector with font styles
      Since:
        JavaView 3.52.002
      Version:
        15.08.04, 1.00 created (kp)

    - #### setLabelFonts

          void setLabelFonts(java.lang.String[] name)

      Set font names of all label types.
      Parameters:
        `name` - Array with font names
      Since:
        JavaView 3.52.002
      Version:
        15.08.04, 1.00 created (kp)

    - #### getDrawingOrder

          int getDrawingOrder()

      Set position of geometry in z-direction in display. Possible values: BACK, STANDARD, FRONT

    - #### setDrawingOrder

          void setDrawingOrder(int anOrder)

      Set position of geometry in z-direction in display. Possible values: BACK, STANDARD, FRONT Currently, only the set of item from geometries of type STANDARD are z-sorted.

    - #### setCenter

          void setCenter(PdVector aVertex)

      Set center of geometry different from center of gravity.

    - #### setGlobalVertexColor

          void setGlobalVertexColor(java.awt.Color color)

      Set global vertex color to be used if no local colors are available.

    - #### setGlobalVertexTagColor

          void setGlobalVertexTagColor(java.awt.Color color)

      Set global vertex color to be used if no local colors are available.

    - #### setGlobalVertexSize

          void setGlobalVertexSize(double aSize)

      Set global thickness of vertex dots.

    - #### setGlobalVertexNormalColor

          void setGlobalVertexNormalColor(java.awt.Color color)

      Set global vertex normal color.

    - #### setGlobalVertexNormalSize

          void setGlobalVertexNormalSize(double aSize)

      Set global thickness of vertex normal vectors.

    - #### setGlobalVertexNormalLength

          void setGlobalVertexNormalLength(double aLength)

      Set global length of vertex normal vectors.

    - #### setGlobalPolygonColor

          void setGlobalPolygonColor(java.awt.Color color)

      Set global polygon color to be used if no local colors are available.

    - #### setGlobalPolygonTagColor

          void setGlobalPolygonTagColor(java.awt.Color color)

      Set global color of tagged polygons.

    - #### setGlobalPolygonSize

          void setGlobalPolygonSize(double aSize)

      Set global thickness of polygon edges.

    - #### setGlobalPolygonNormalColor

          void setGlobalPolygonNormalColor(java.awt.Color color)

      Set global color of polygon normals.

    - #### setGlobalPolygonNormalSize

          void setGlobalPolygonNormalSize(double aSize)

      Set global thickness of polygon normal vectors.

    - #### setGlobalPolygonNormalLength

          void setGlobalPolygonNormalLength(double aLength)

      Set global length of polygon normal vectors.

    - #### setGlobalEdgeColor

          void setGlobalEdgeColor(java.awt.Color color)

      Set global edge color to be used if no local colors are available.

    - #### setGlobalEdgeTagColor

          void setGlobalEdgeTagColor(java.awt.Color color)

      Set global color of tagged edges.

    - #### setGlobalEdgeSize

          void setGlobalEdgeSize(double aSize)

      Set global thickness of element edges.

    - #### setGlobalElementColor

          void setGlobalElementColor(java.awt.Color color)

      Set global element color to be used if no local colors are available.

    - #### setGlobalElementBackColor

          void setGlobalElementBackColor(java.awt.Color color)

      Set global color of backface of elements.

    - #### setGlobalElementTagColor

          void setGlobalElementTagColor(java.awt.Color color)

      Set global color of tagged elements.

    - #### setGlobalElementNormalColor

          void setGlobalElementNormalColor(java.awt.Color color)

      Set global vertex normal color.

    - #### setGlobalElementNormalSize

          void setGlobalElementNormalSize(double aSize)

      Set global thickness of vertex normal vectors.

    - #### setGlobalElementNormalLength

          void setGlobalElementNormalLength(double aLength)

      Set global length of vertex normal vectors.

    - #### setCreaseAngle

          void setCreaseAngle(double angle)

      Set crease angle which is a threshold determining sharp crease edges.
      Since:
        JavaView 3.03.007

    - #### setNumBndPolygons

          void setNumBndPolygons(int num)

      Set number of allocated and used vector fields.
      Parameters:
        `num` - number of vector fields
      Since:
        JavaView 3.98.003

    - #### setBndName

          void setBndName(int ind,
                          java.lang.String name)

      Set thickness in pixels of boundary polygon.

    - #### setBndElementInd

          void setBndElementInd(int ind,
                                PiVector elemInd)

      Set indices of surface elements along boundary.

    - #### setBndNeighbourLocInd

          void setBndNeighbourLocInd(int ind,
                                     PiVector oppLocInd)

      Set local indices of opposite vertices of edge in surface element.

    - #### showBnd

          void showBnd(int ind,
                       boolean flag)

      Set visibility of boundary polygon.

    - #### setGlobalBndColor

          void setGlobalBndColor(java.awt.Color color)

      Set global boundary color.

    - #### setGlobalBndTagColor

          void setGlobalBndTagColor(java.awt.Color color)

      Set global color of tagged boundaries.

    - #### setBndColor

          boolean setBndColor(int ind,
                              java.awt.Color color)

      Set global color of individual boundary polygon unless all have same color.

    - #### setGlobalBndSize

          void setGlobalBndSize(double aSize)

      Set global thickness of boundary edges.

    - #### setBndSize

          boolean setBndSize(int ind,
                             double size)

      Set thickness in pixels of boundary polygon.

    - #### showBndMaterials

          void showBndMaterials(int ind,
                                boolean flag)

      Set flag if this boundary polygon uses its own material properties instead of inheriting material properties of the base geometry.
      Since:
        JavaView 3.98.003

    - #### setDimOfVertices

          void setDimOfVertices(int dim)

      Set dimension of points used in geometry, i.e. the number coordinates per point.
      Since:
        JavaView 2.48
      Version:
        11.12.02, 1.00 created (kp) Allow to update dimension of internal variables of display geometry.

    - #### setNumVertices

          void setNumVertices(int numVertices)

      Set number of used vertices.

    - #### setVertices

          void setVertices(PdVector[] vertices)

      Set array of vertex coordinates.

    - #### setVertexColors

          void setVertexColors(java.awt.Color[] colors)

      Set array of vertex colors.

    - #### setVertexNormals

          void setVertexNormals(PdVector[] normals)

      Set array of vertex normal vectors.

    - #### setVertexSizes

          void setVertexSizes(PdVector sizes)

      Set individual thickness of all vertices.
      Since:
        JavaView 2.43

    - #### setVertexTextures

          void setVertexTextures(PdVector[] tex)

      Set array of vertex texture coordinates.

    - #### setTexture

          void setTexture(int[] texturePix,
                          int width,
                          int height,
                          int blendingMode,
                          int filteringType)

      Set texture image as array of pixels and image dimensions with no multiple repetition.
      Since:
        JavaView 2.43
      See Also:
        `setTexture(int [], int, int, int, int, int, int, int, int)`

    - #### setTexture

          void setTexture(int[] texturePix,
                          int width,
                          int height,
                          int uRepeat,
                          int vRepeat,
                          int periodic,
                          int blendingMode,
                          int filteringType,
                          int textureSide)

      Set texture image as array of pixels and image dimensions with multiple repetition.
      Since:
        JavaView 3.96.012
      See Also:
        `setTexture(int [], int, int, int, int)`
      Version:
        18.06.06, 2.10 revised (kp) Parameter textureSide added.

    - #### setNumVectorFields

          void setNumVectorFields(int num)

      Set number of allocated and used vector fields.
      Parameters:
        `num` - number of vector fields

    - #### setNumVectors

          void setNumVectors(int ind,
                             int num,
                             int dimOfVectors)

      Set number of vectors of a vector field with given index.
      Parameters:
        `ind` - index of vector field
        `num` - number of vectors in that vector field
        `dimOfVectors` - dim of vectors in that vector field

    - #### setVectors

          void setVectors(int ind,
                          PdVector[] list)

      Copy all vectors of vector list to existing array of vectors. Length of argument vector list must be equal or larger than getNumVectors(). All vectors are copied. The dimension of all argument vectors must be equal to previous declaration in setNumVectors(int, int, int) of the vector field.
      Parameters:
        `ind` - index of vector field
        `list` - array with new vectors

    - #### setVectorColors

          void setVectorColors(int ind,
                               java.awt.Color[] list)

      Copy vector colors of list to existing array of vector colors. Length of argument list must be equal or larger than getNumVectors(int).
      Parameters:
        `ind` - index of vector field
        `list` - array with new vector colors

    - #### setVectorElementBased

          void setVectorElementBased(int ind,
                                     boolean flag)

      Set flag if vector field is element based or vertex based.
      Parameters:
        `ind` - index of vector field.
        `flag` - true if element based vf, false if vertex based vf.

    - #### showVectorFields

          void showVectorFields(boolean flag)

      Set flag to enable drawing of all vector fields which are visible. Note, a vf is visible if global AND its own local visibility is switched on.
      Since:
        JavaView 3.10.004
      Version:
        29.02.04, 1.00 created (kp)

    - #### showVectorField

          void showVectorField(int ind,
                               boolean flag)

      Set flag to enable drawing of vectors of a vector field.

    - #### showVectorArrows

          void showVectorArrows(int ind,
                                boolean flag)

      Set flag if tip of vectors is shown as arrow.

    - #### showVectorColors

          void showVectorColors(int ind,
                                boolean flag)

      Set flag to enable drawing of individual vertex colors of a vector field.

    - #### setGlobalVectorColor

          boolean setGlobalVectorColor(int ind,
                                       java.awt.Color aColor)

      Set global color of vector field to be used if no local colors are available.

    - #### setGlobalVectorLength

          boolean setGlobalVectorLength(int ind,
                                        double aLength)

      Set length factor of vectors when drawn in display.

    - #### setGlobalVectorSize

          boolean setGlobalVectorSize(int ind,
                                      double aSize)

      Set thickness in pixels of vectors when drawn in display.

    - #### setDimOfPolygons

          void setDimOfPolygons(int dim)

      Set dimension of polygons used in geometry, i.e. the number vertices per polygon. If the number is not uniform for all elements then use -1.
      Since:
        JavaView 2.69
      Version:
        26.04.03, 1.00 created (kp)

    - #### setNumPolygons

          void setNumPolygons(int numPolygons)

      Set number of polygons of geometry.

    - #### setPolygons

          void setPolygons(PiVector[] vertices)

      Set polygons of geometry.

    - #### setPolygonColors

          void setPolygonColors(java.awt.Color[] colors)

      Set individual colors of polygons.

    - #### setPolygonNormals

          void setPolygonNormals(PdVector[] normals)

      Set individual normal vectors of polygons.

    - #### setPolygonSizes

          void setPolygonSizes(PdVector sizes)

      Set individual thickness of polygon edges.
      Since:
        JavaView 3.09
      Version:
        07.02.04, 1.00 created (kp)

    - #### setDimOfElements

          void setDimOfElements(int dim)

      Set dimension of element used in geometry, i.e. the number vertices per element. If the number is not uniform for all elements then use -1.
      Since:
        JavaView 2.69
      Version:
        26.04.03, 1.00 created (kp)

    - #### setNumElements

          void setNumElements(int numElements)

      Set number of elements of geometry.

    - #### setElements

          void setElements(PiVector[] elements)

      Set elements of geometry.

    - #### setElementColors

          void setElementColors(java.awt.Color[] colors)

      Set individual colors of elements.

    - #### setElementBackColors

          void setElementBackColors(java.awt.Color[] color)

      Set individual backface colors of elements.

    - #### setElementNormals

          void setElementNormals(PdVector[] normals)

      Set individual normals of elements.

    - #### setElementTextures

          void setElementTextures(PdVector[][] texCoords)

      Set individual texture coordinates for all vertices of all elements.

    - #### setNeighbours

          void setNeighbours(PiVector[] neighbours)

      Set individual neighbours of elements.

    - #### setNumEdges

          void setNumEdges(int numEdges)

      Set number of edges of an element set.

    - #### setEdges

          void setEdges(PiVector[] edge)

      Set list of all edges.
      Since:
        JavaView 3.96.031
      Version:
        06.07.07, 1.00 created (kp)

    - #### setElementEdges

          void setElementEdges(PiVector[] elementEdge)

      Set for all elements a list of indices of incident edges.
      Since:
        JavaView 3.96.031
      Version:
        06.07.07, 1.00 created (kp)

    - #### setEdgeColors

          void setEdgeColors(java.awt.Color[] color)

      Set individual color of all edges.
      Since:
        JavaView 3.96.031
      Version:
        06.07.07, 1.00 created (kp)

    - #### setEdgeSizes

          void setEdgeSizes(PdVector size)

      Set individual thickness of all edges.
      Since:
        JavaView 3.96.031
      Version:
        06.07.07, 1.00 created (kp)

    - #### setModelMatrix

          void setModelMatrix(PdMatrix modelMat)

      Set model matrix of geometry.

    - #### setAmbientMatrix

          void setAmbientMatrix(PdMatrix ambientMat,
                                PdMatrix ambientInvMat)

      Set model matrix of geometry within original ambient space.

    - #### setShininess

          void setShininess(double shininess)

      Set shininess of geometry.

    - #### setSpecularColor

          void setSpecularColor(java.awt.Color col)

      Set specular color of geometry.

    - #### setTransparency

          void setTransparency(double alpha)

      Set transparency in [0, 1] where 0 corresponds to opaque and 1 to fully transparent.

    - #### isVisible

          boolean isVisible()

      Flag whether geometry is hidden or visible in display.

    - #### setVisible

          void setVisible(boolean flag)

      Set geometry to be hidden or visible in display.

    - #### getAmbientSpace

          int getAmbientSpace()

      Get ambient space used in model transformations.

    - #### setAmbientSpace

          void setAmbientSpace(int mode)

      Set ambient space used in model transformations.

    - #### getAmbientProjection

          int getAmbientProjection()

      Get projection mode of ambient space used in model transformations.

    - #### setAmbientProjection

          void setAmbientProjection(int mode)

      Set projection mode of ambient space used in model transformations.

"

The software JavaView? is copyright protected. All Rights Reserved.
"